#!/usr/bin/env python
#this file isn't ready to use now - gsm-receiver lacks realtime processing capability 
#there are many underruns of buffer for samples from usrp's, many blocks of samples get lost and
#receiver isn't prepared for this situation too well

from gnuradio import gr, gru, blks2, eng_notation
#, gsm
from gnuradio import usrp
from gnuradio.eng_option import eng_option
from optparse import OptionParser
from os import sys


from gnuradio import gr, gru, eng_notation, optfir
from gnuradio import usrp
from gnuradio.eng_option import eng_option
import math
import sys
from numpy.numarray import fft
from optparse import OptionParser
from gnuradio.wxgui import stdgui2, fftsink2, scopesink2
import wx

for extdir in ['../../debug/src/lib','../../debug/src/lib/.libs','../lib','../lib/.libs']:
    if extdir not in sys.path:
        sys.path.append(extdir)
import gsm  

####################
def get_freq_from_arfcn(chan,region):

	#P/E/R-GSM 900
	if chan >= 0 and chan <= 124:
		freq = 890 + 0.2*chan + 45

	#GSM 850
	elif chan >= 128 and chan <= 251:
		freq = 824.2 + 0.2*(chan - 128) + 45
		
	#GSM 450
	elif chan >= 259 and chan <= 293:
		freq = 450.6 + 0.2*(chan - 259) + 10
		
	#GSM 480
	elif chan >= 306 and chan <= 340:
		freq = 479 + 0.2*(chan - 306) + 10
		
	#DCS 1800
	elif region is "e" and chan >= 512 and chan <= 885:
		freq = 1710.2 + 0.2*(chan - 512) + 95
		
	#DCS 1900
	elif region is "u" and chan >= 512 and chan <= 810:
		freq = 1850.2 + 0.2*(chan - 512) + 80

	#E/R-GSM 900
	elif chan >= 955 and chan <= 1023:
		freq = 890 + 0.2*(chan - 1024) + 45

	else:
		freq = 0

	return freq * 1e6
                      

class tuner(gr.feval_dd):
    def __init__(self, top_block):
        gr.feval_dd.__init__(self)
        self.top_block = top_block
    def eval(self, freq_offet):
        self.top_block.set_center_frequency(freq_offet)
        return freq_offet
        
class synchronizer(gr.feval_dd):
    def __init__(self, top_block):
        gr.feval_dd.__init__(self)
        self.top_block = top_block

    def eval(self, timing_offset):
        self.top_block.set_timing(timing_offset)
        return freq_offet

class gsm_receiver_first_blood(gr.top_block):
    def __init__(self):
        gr.top_block.__init__(self)
        (options, args) = self._process_options()
        self.tuner_callback = tuner(self)
        self.synchronizer_callback = synchronizer(self)
        self.options    = options
        self.args       = args
        self._set_rates()

        self.source = self._set_source()
        #self.filtr  = self._set_filter()

        self.s2p = gr.deinterleave(gr.sizeof_gr_complex)
        self.connect(self.source, self.s2p)

        self.source1 = (self.s2p,0)
        self.filtr1 = self._set_filter()

        self.source2 = (self.s2p,1)
        self.filtr2 = self._set_filter()

        self.interpolator1 = self._set_interpolator()
        self.interpolator2 = self._set_interpolator()

        self.receiver = self._set_receiver()
        self.converter = self._set_converter()
        self.sink = self._set_sink()

    
#        self.connect(self.source, self.filtr,  self.interpolator, self.receiver, self.converter, self.sink)
        self.connect(self.source1, self.filtr1, self.receiver)
        #self.connect(self.source2, self.filtr2,  self.interpolator2, (self.receiver,1))

    def _set_sink(self):
        nazwa_pliku_wy = self.options.outputfile
        ujscie = gr.file_sink(gr.sizeof_float, nazwa_pliku_wy)
        return ujscie
    
    def _set_source(self):
        options = self.options
        fusb_block_size = gr.prefs().get_long('fusb', 'block_size', 4096)
        fusb_nblocks    = gr.prefs().get_long('fusb', 'nblocks', 16)

        self.decim2x = options.decim
        self.usrp = usrp.source_c(decim_rate=self.decim2x, fusb_block_size=fusb_block_size, fusb_nblocks=fusb_nblocks)

        antenna_num = 2
        self.usrp.set_nchannels(antenna_num)

        # (0,0) is A side; (1,0) is B side
        subdev_a = usrp.selected_subdev(self.usrp, (0,0))
        subdev_b = usrp.selected_subdev(self.usrp, (1,0))
        print "A side:", subdev_a.name()
        print "B side:", subdev_b.name()
        subdev_a.select_rx_antenna('TX/RX')
        subdev_b.select_rx_antenna('TX/RX')

        # set initial values

        if options.gain is None:
           # if no gain was specified, use the mid-point in dB
           g = subdev_a.gain_range()
           gain_a = float(g[0]+g[1])/2

           g = subdev_b.gain_range()
           gain_b = float(g[0]+g[1])/2
        else:
           gain_a = options.gain
           gain_b = options.gain

        print "gain_a:", gain_a
        print "gain_b:", gain_b

        subdev_a.set_gain(gain_a)
        subdev_b.set_gain(gain_b)
	 
        subdev_a.set_auto_tr(False)
        subdev_b.set_auto_tr(False)

        freq_a = get_freq_from_arfcn(options.channel,options.region)
        freq_b = get_freq_from_arfcn(options.channel,options.region)

        r = self.usrp.tune(0, subdev_a, freq_a)
        if not(r):
        	print "A side: Failed to set initial frequency"
        else:
              print "A side: The carrier frequency is set as ", freq_a

        r = self.usrp.tune(1, subdev_b, freq_b)
        if not(r):
        	print "B side: Failed to set initial frequency"
        else:
              print "B side: The carrier frequency is set as ", freq_b

        mux_val = self.usrp.determine_rx_mux_value((0,0),(1,0))
        print "mux_val = 0x%x" % gru.hexint(mux_val)

        self.usrp.set_mux(mux_val)
        #self.usrp.set_mux(usrp.determine_rx_mux_value(self.usrp, (0,0)))
        
        return self.usrp

   
    def _set_rates(self):
        options = self.options
        clock_rate = 64e6
        self.clock_rate = clock_rate  
        self.input_rate = clock_rate / options.decim
        self.gsm_symb_rate = 1625000.0 / 6.0
        self.sps = self.input_rate / self.gsm_symb_rate / self.options.osr 

    def _set_filter(self):
        filter_cutoff   = 145e3	
        filter_t_width  = 10e3
        offset = 0
        print "input_rate:", self.input_rate, "sample rate:", self.sps, " filter_cutoff:", filter_cutoff, " filter_t_width:", filter_t_width
        filter_taps     = gr.firdes.low_pass(1.0, self.input_rate, filter_cutoff, filter_t_width, gr.firdes.WIN_HAMMING)
        filtr          = gr.freq_xlating_fir_filter_ccf(1, filter_taps, offset, self.input_rate)
        return filtr

    def _set_converter(self):
        v2s = gr.vector_to_stream(gr.sizeof_float, 142)
        return v2s
    
    def _set_interpolator(self):
        interpolator = gr.fractional_interpolator_cc(0, self.sps) 
        return interpolator
    
    def _set_receiver(self):
        receiver = gsm.receiver_cf(self.tuner_callback, self.synchronizer_callback, self.options.osr, self.options.key.replace(' ', '').lower(), self.options.configuration.upper())
        return receiver
    
    def _process_options(self):
        parser = OptionParser(option_class=eng_option)
        parser.add_option("-d", "--decim", type="int", default=112,
                                    help="Set USRP decimation rate to DECIM [default=%default]")
        parser.add_option("-r", "--osr", type="int", default=4,
                          help="Oversampling ratio [default=%default]")
        parser.add_option("-I", "--inputfile", type="string", default="cfile",
                                    help="Input filename")
        parser.add_option("-O", "--outputfile", type="string", default="cfile2.out",
                                    help="Output filename")
        parser.add_option("-R", "--rx-subdev-spec", type="subdev", default=None,
                                    help="Select USRP Rx side A or B (default=first one with a daughterboard)")
        parser.add_option("-f", "--freq", type="eng_float", default="950.4M",
                                    help="set frequency to FREQ", metavar="FREQ")
        parser.add_option("-g", "--gain", type="eng_float", default=None,
                                    help="Set gain in dB (default is midpoint)")
        parser.add_option("-k", "--key", type="string", default="00 00 00 00 00 00 00 00",
                                   help="KC session key")
        parser.add_option("-s", "--configuration", type="string",default="0C", 
                                   help="Decoder configuration")
        parser.add_option("-c", "--channel", type="int", default=112, 
                                   help="Tune to GSM ARFCN.")
        parser.add_option("-n", "--region", type="string", default="e", 
                                   help="Frequency bands to use for channels.  (u)s or (e)urope [default=%default]")


        (options, args) = parser.parse_args ()
        return (options, args)
    
    def set_center_frequency(self, center_freq):
        self.filtr1.set_center_freq(center_freq)
        #self.filtr2.set_center_freq(center_freq)
        pass

    def set_timing(self, timing_offset):
        pass

def main():
    try:
        gsm_receiver_first_blood().run()
    except KeyboardInterrupt:
        pass


if __name__ == '__main__':
    main()
